/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.configuracioneccomerciales;

import com.rjconsultores.ventaboletos.entidad.Ciudad;
import com.rjconsultores.ventaboletos.entidad.Moneda;
import com.rjconsultores.ventaboletos.entidad.TipoCambioCtrl;
import com.rjconsultores.ventaboletos.service.MonedaService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderTipoCambioCtrl;
import java.util.HashMap;
import com.trg.search.Filter;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Datebox;
import org.zkoss.zul.Decimalbox;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Paging;

/**
 *
 * @author Administrador
 */
@Controller("busquedaTipoCambioCiudadController")
@Scope("prototype")
public class BusquedaTipoCambioCiudadController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<TipoCambioCtrl> plwTipoCambioCiudad;
    @Autowired
    private MonedaService monedaService;
    private MyListbox tipoCambioCiudadList;
    private Paging pagingTipoCambioCiudad;
    private Combobox cmbMonedaOrigen;
    private Combobox cmbMonedaDestino;
    private Combobox cmbCiudad;
    private List<Moneda> lsMoneda;
    private Decimalbox decImportecambio;
    private Datebox dtFecaplicacionAte;
    private Datebox dtFecaplicacionDe;

    public Combobox getCmbMonedaDestino() {
        return cmbMonedaDestino;
    }

    public void setCmbMonedaDestino(Combobox cmbMonedaDestino) {
        this.cmbMonedaDestino = cmbMonedaDestino;
    }

    public Combobox getCmbMonedaOrigen() {
        return cmbMonedaOrigen;
    }

    public void setCmbMonedaOrigen(Combobox cmbMonedaOrigen) {
        this.cmbMonedaOrigen = cmbMonedaOrigen;
    }

    public Decimalbox getDecImportecambio() {
        return decImportecambio;
    }

    public void setDecImportecambio(Decimalbox decImportecambio) {
        this.decImportecambio = decImportecambio;
    }

    public List<Moneda> getLsMoneda() {
        return lsMoneda;
    }

    public void setLsMoneda(List<Moneda> lsMoneda) {
        this.lsMoneda = lsMoneda;
    }

    public Paging getPagingTipoCambioCiudad() {
        return pagingTipoCambioCiudad;
    }

    public void setPagingTipoCambioCiudad(Paging pagingTipoCambioCiudad) {
        this.pagingTipoCambioCiudad = pagingTipoCambioCiudad;
    }

    public MyListbox getTipoCambioCiudadList() {
        return tipoCambioCiudadList;
    }

    public void setTipoCambioCiudadList(MyListbox tipoCambioCiudadList) {
        this.tipoCambioCiudadList = tipoCambioCiudadList;
    }

    public Datebox getDtFecaplicacionAte() {
        return dtFecaplicacionAte;
    }

    public void setDtFecaplicacionAte(Datebox dtFecaplicacionAte) {
        this.dtFecaplicacionAte = dtFecaplicacionAte;
    }

    public Datebox getDtFecaplicacionDe() {
        return dtFecaplicacionDe;
    }

    public void setDtFecaplicacionDe(Datebox dtFecaplicacionDe) {
        this.dtFecaplicacionDe = dtFecaplicacionDe;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        lsMoneda = monedaService.obtenerTodos();

        tipoCambioCiudadList.setItemRenderer(new RenderTipoCambioCtrl());
        tipoCambioCiudadList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                TipoCambioCtrl c = (TipoCambioCtrl) tipoCambioCiudadList.getSelected();
                verTipoCambioCiudad(c);
            }
        });

        refreshLista();
        dtFecaplicacionDe.focus();
    }

    private void verTipoCambioCiudad(TipoCambioCtrl c) {
        if (c == null) {
            return;
        }

        Map args = new HashMap();
        args.put("tipoCambioCtrl", c);
        args.put("tipoCambioCiudadList", tipoCambioCiudadList);

        openWindow("/gui/configuraciones_comerciales/editarTipoCambioCiudad.zul",
                Labels.getLabel("busquedaTipoCambioCiudadController.window.title"),
                args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<TipoCambioCtrl> tipoCambioCidadBusqueda =
                new HibernateSearchObject<TipoCambioCtrl>(TipoCambioCtrl.class,
                pagingTipoCambioCiudad.getPageSize());

        tipoCambioCidadBusqueda.addFilterEqual("importecambio", decImportecambio.getValue());

        Comboitem itemMonedaOrigen = cmbMonedaOrigen.getSelectedItem();
        Moneda monedaOrigen;
        if (itemMonedaOrigen != null) {
            monedaOrigen = (Moneda) itemMonedaOrigen.getValue();
            tipoCambioCidadBusqueda.addFilterEqual("monedaOrigen", monedaOrigen);
        }

        Comboitem itemMonedaDestino = cmbMonedaDestino.getSelectedItem();
        Moneda monedaDestino;
        if (itemMonedaDestino != null) {
            monedaDestino = (Moneda) itemMonedaDestino.getValue();
            tipoCambioCidadBusqueda.addFilterEqual("monedaDestino", monedaDestino);
        }

        Comboitem itemCiudad = cmbCiudad.getSelectedItem();
        Ciudad ciudad;
        if (itemCiudad != null) {
            ciudad = (Ciudad) itemCiudad.getValue();
            tipoCambioCidadBusqueda.addFilterSome("tipoCambioCiudadList",
                    Filter.equal("ciudad.ciudadId", ciudad.getCiudadId()));
        }

        tipoCambioCidadBusqueda.addFilterGreaterOrEqual("fecaplicacion",
                dtFecaplicacionDe.getValue());
        tipoCambioCidadBusqueda.addFilterLessOrEqual("fecaplicacion",
                dtFecaplicacionAte.getValue());

        tipoCambioCidadBusqueda.addFilterEqual("activo", Boolean.TRUE);
        tipoCambioCidadBusqueda.addSortAsc("tipoCambioCiudadList.ciudad.nombciudad");

        plwTipoCambioCiudad.init(tipoCambioCidadBusqueda, tipoCambioCiudadList, pagingTipoCambioCiudad);

        if (tipoCambioCiudadList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaTipoCambioCiudadController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }

    public void onClick$btnPesquisa(Event ev) {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verTipoCambioCiudad(new TipoCambioCtrl());
    }
}
